Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 3938)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 3938)
@@ -0,0 +1,461 @@
+MODULE limupdate1
+   !!======================================================================
+   !!                     ***  MODULE  limupdate1  ***
+   !!   LIM-3 : Update of sea-ice global variables at the end of the time step
+   !!======================================================================
+   !! History :  3.0  !  2006-04  (M. Vancoppenolle) Original code
+   !!----------------------------------------------------------------------
+#if defined key_lim3
+   !!----------------------------------------------------------------------
+   !!   'key_lim3'                                      LIM3 sea-ice model
+   !!----------------------------------------------------------------------
+   !!    lim_update1   : computes update of sea-ice global variables from trend terms
+   !!----------------------------------------------------------------------
+   USE limrhg          ! ice rheology
+
+   USE dom_oce
+   USE oce             ! dynamics and tracers variables
+   USE in_out_manager
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE sbc_ice         ! Surface boundary condition: ice fields
+   USE dom_ice
+   USE phycst          ! physical constants
+   USE ice
+   USE limdyn
+   USE limtrp
+   USE limthd
+   USE limsbc
+   USE limdia
+   USE limdiahsb
+   USE limwri
+   USE limrst
+   USE thd_ice         ! LIM thermodynamic sea-ice variables
+   USE par_ice
+   USE limitd_th
+   USE limvar
+   USE prtctl           ! Print control
+   USE lbclnk           ! lateral boundary condition - MPP exchanges
+   USE wrk_nemo         ! work arrays
+   USE lib_fortran     ! glob_sum
+   ! Check budget (Rousset)
+   USE in_out_manager   ! I/O manager
+   USE iom              ! I/O manager
+   USE lib_mpp          ! MPP library
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   lim_update1   ! routine called by ice_step
+
+      REAL(wp)  ::   epsi06 = 1.e-06_wp   ! module constants
+      REAL(wp)  ::   epsi04 = 1.e-04_wp   !    -       -
+      REAL(wp)  ::   epsi03 = 1.e-03_wp   !    -       -
+      REAL(wp)  ::   epsi10 = 1.e-10_wp   !    -       -
+      REAL(wp)  ::   epsi16 = 1.e-16_wp   !    -       -
+      REAL(wp)  ::   epsi20 = 1.e-20_wp   !    -       -
+      REAL(wp)  ::   rzero  = 0._wp       !    -       -
+      REAL(wp)  ::   rone   = 1._wp       !    -       -
+         
+   !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! $Id: limupdate.F90 3294 2012-01-28 16:44:18Z rblod $
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE lim_update1
+      !!-------------------------------------------------------------------
+      !!               ***  ROUTINE lim_update1  ***
+      !!               
+      !! ** Purpose :  Computes update of sea-ice global variables at 
+      !!               the end of the time step.
+      !!               Address pathological cases
+      !!               This place is very important
+      !!                
+      !! ** Method  :  
+      !!    Ice speed from ice dynamics
+      !!    Ice thickness, Snow thickness, Temperatures, Lead fraction
+      !!      from advection and ice thermodynamics 
+      !!
+      !! ** Action  : - 
+      !!---------------------------------------------------------------------
+      INTEGER ::   ji, jj, jk, jl, jm    ! dummy loop indices
+      INTEGER ::   jbnd1, jbnd2
+      INTEGER ::   i_ice_switch
+      INTEGER ::   ind_im, layer      ! indices for internal melt
+      REAL(wp) ::   zweight, zesum, z_da_i
+      REAL(wp) ::   zindb, zindsn, zindic
+      REAL(wp) ::   zindg, zh, zdvres, zviold2
+      REAL(wp) ::   zbigvalue, zvsold2, z_da_ex
+      REAL(wp) ::   z_prescr_hi, zat_i_old, ztmelts, ze_s
+
+      REAL(wp), POINTER, DIMENSION(:) ::   zthick0, zqm0      ! thickness of the layers and heat contents for
+      REAL(wp) :: zchk_v_i, zchk_smv, zchk_fs, zchk_fw, zchk_v_i_b, zchk_smv_b, zchk_fs_b, zchk_fw_b ! Check conservation (C Rousset)
+      ! mass and salt flux (clem)
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zviold, zvsold, zsmvold   ! old ice volume...
+      !!-------------------------------------------------------------------
+
+      CALL wrk_alloc( jkmax, zthick0, zqm0 )
+
+      CALL wrk_alloc( jpi,jpj,jpl,zviold, zvsold, zsmvold )   ! clem
+
+      !------------------------------------------------------------------------------
+      ! 1. Update of Global variables                                               |
+      !------------------------------------------------------------------------------
+
+      !---------------------
+      ! Ice dynamics  
+      !---------------------
+      u_ice(:,:) = u_ice(:,:) + d_u_ice_dyn(:,:)
+      v_ice(:,:) = v_ice(:,:) + d_v_ice_dyn(:,:)
+ 
+      !-----------------------------
+      ! Update ice and snow volumes  
+      !-----------------------------
+      DO jl = 1, jpl
+         v_i(:,:,jl)  = v_i(:,:,jl) + d_v_i_trp(:,:,jl) 
+         v_s(:,:,jl)  = v_s(:,:,jl) + d_v_s_trp(:,:,jl)
+      END DO
+
+
+      !---------------------------------------------
+      ! Ice concentration and ice heat content
+      !---------------------------------------------
+      a_i (:,:,:)  = a_i (:,:,:) + d_a_i_trp(:,:,:)
+      e_i(:,:,:,:) = e_i(:,:,:,:) + d_e_i_trp(:,:,:,:)  
+
+      !------------------------------
+      ! Snow temperature and ice age
+      !------------------------------
+      e_s (:,:,:,:) = e_s (:,:,:,:) + d_e_s_trp (:,:,:,:)
+      oa_i(:,:,:)   = oa_i(:,:,:)   + d_oa_i_trp(:,:,:)  
+
+      !--------------
+      ! Ice salinity    
+      !--------------
+      IF(  num_sal == 2  .OR.  num_sal == 4  ) THEN      ! general case
+         smv_i(:,:,:) = smv_i(:,:,:) + d_smv_i_trp(:,:,:)
+      ENDIF
+
+      ! mass and salt flux init (clem)
+      zviold(:,:,:) = v_i(:,:,:)
+      zvsold(:,:,:) = v_s(:,:,:)
+      zsmvold(:,:,:) = smv_i(:,:,:)
+
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_v_i_b = glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_smv_b = glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_fw_b  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) )
+         zchk_fs_b  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) )
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+
+      CALL lim_var_glo2eqv
+
+      !---------------------------------
+      ! Classify the pathological cases
+      !---------------------------------
+      ! (1) v_i (new) > 0; d_v_i_thd + v_i(old) > 0 (easy case)
+      ! (3) v_i (new) < 0; d_v_i_thd + v_i(old) > 0 (combined total ablation)
+      ! (5) v_i (old) = 0; d_v_i_trp > 0 (advection of ice in a free-cell)
+      !
+      DO jl = 1, jpl
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               patho_case(ji,jj,jl) = 1
+               IF( v_i(ji,jj,jl) .LT. 0.0 ) THEN
+                  patho_case(ji,jj,jl) = 3
+               ENDIF
+               IF( ( old_v_i(ji,jj,jl) .LE. epsi10 ) .AND. ( d_v_i_trp(ji,jj,jl) .GT. epsi06 ) ) THEN
+                  patho_case(ji,jj,jl) = 5 ! advection of ice in an ice-free cell
+               ENDIF
+            END DO
+         END DO
+      END DO
+
+      !--------------------------------------
+      ! 2. Review of all pathological cases
+      !--------------------------------------
+     
+      at_i(:,:) = 0._wp
+      DO jl = 1, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+
+      !----------------------------------------------------
+      ! 2.2) Rebin categories with thickness out of bounds
+      !----------------------------------------------------
+      DO jm = 1, jpm
+         jbnd1 = ice_cat_bounds(jm,1)
+         jbnd2 = ice_cat_bounds(jm,2)
+         IF (ice_ncat_types(jm) .GT. 1 )   CALL lim_itd_th_reb(jbnd1, jbnd2, jm)
+      END DO
+
+      at_i(:,:) = 0._wp
+      DO jl = 1, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+
+      zbigvalue      = 1.0e+20
+
+      DO jl = 1, jpl
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+
+               !switches
+               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi06 ) ) 
+               !switch = 1 if a_i > 1e-06 and 0 if not
+               zindsn        = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi06 ) ) !=1 if hs > 1e-6 and 0 if not
+               zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) !=1 if hi > 1e-3 and 0 if not
+               ! bug fix 25 avril 2007
+               zindb         = zindb*zindic
+
+               !--- 2.3 Correction to ice age 
+               !------------------------------
+               !                IF ((o_i(ji,jj,jl)-1.0)*86400.0.gt.(rdt_ice*float(numit))) THEN
+               !                   o_i(ji,jj,jl) = rdt_ice*FLOAT(numit)/86400.0
+               !                ENDIF
+               IF ((oa_i(ji,jj,jl)-1.0)*86400.0.gt.(rdt_ice*numit*a_i(ji,jj,jl))) THEN
+                  oa_i(ji,jj,jl) = rdt_ice*numit/86400.0*a_i(ji,jj,jl)
+               ENDIF
+               oa_i(ji,jj,jl) = zindb*zindic*oa_i(ji,jj,jl)
+
+               !--- 2.4 Correction to snow thickness
+               !-------------------------------------
+               !          ! snow thickness has to be greater than 0, and if ice concentration smaller than 1e-6 then hs = 0
+               !             v_s(ji,jj,jl)  = MAX( zindb * v_s(ji,jj,jl), 0.0) 
+               ! snow thickness cannot be smaller than 1e-6
+               zdvres = (zindsn * zindb - 1._wp) * v_s(ji,jj,jl)
+               v_s(ji,jj,jl) = v_s(ji,jj,jl) + zdvres
+
+               !rdmsnif(ji,jj) = rdmsnif(ji,jj) + zdvres * rhosn
+ 
+               !--- 2.5 Correction to ice thickness
+               !-------------------------------------
+               zdvres = (zindb - 1._wp) * v_i(ji,jj,jl)
+               v_i(ji,jj,jl) = v_i(ji,jj,jl) + zdvres
+
+               !rdmicif(ji,jj) = rdmicif(ji,jj) + zdvres * rhoic
+               !fsalt_res(ji,jj)  = fsalt_res(ji,jj) - sm_i(ji,jj,jl) * ( rhoic * zdvres / rdt_ice )
+
+               !--- 2.6 Snow is transformed into ice if the original ice cover disappears
+               !----------------------------------------------------------------------------
+               zindg          = tms(ji,jj) *  MAX( 0._wp, SIGN( 1._wp, -v_i(ji,jj,jl) ) )
+               v_i(ji,jj,jl)  = v_i(ji,jj,jl) + zindg * rhosn * v_s(ji,jj,jl) / rau0
+               v_s(ji,jj,jl)  = ( 1._wp - zindg ) * v_s(ji,jj,jl) + zindg * v_i(ji,jj,jl) * ( rau0 - rhoic ) / rhosn
+
+               !--- 2.7 Correction to ice concentrations 
+               !--------------------------------------------
+               ! if greater than 0, ice concentration cannot be smaller than 1e-10
+               !clem a_i(ji,jj,jl) = zindb * MAX(zindsn, zindic) * MAX( a_i(ji,jj,jl), epsi06 )
+               a_i(ji,jj,jl) = zindb * a_i(ji,jj,jl)
+
+               !-------------------------
+               ! 2.8) Snow heat content
+               !-------------------------
+               e_s(ji,jj,1,jl) = zindsn * ( MIN ( MAX ( 0._wp, e_s(ji,jj,1,jl) ), zbigvalue ) )
+
+            END DO ! ji
+         END DO ! jj
+      END DO ! jl
+
+      !------------------------
+      ! 2.9) Ice heat content 
+      !------------------------
+
+      DO jl = 1, jpl
+         DO jk = 1, nlay_i
+            DO jj = 1, jpj 
+               DO ji = 1, jpi
+                  zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) 
+                  e_i(ji,jj,jk,jl)= zindic * ( MIN ( MAX ( 0.0, e_i(ji,jj,jk,jl) ), zbigvalue ) )
+               END DO ! ji
+            END DO ! jj
+         END DO !jk
+      END DO !jl
+ 
+      at_i(:,:) = 0._wp
+      DO jl = 1, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+
+      !--- 2.13 ice concentration should not exceed amax 
+      !-----------------------------------------------------
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            z_da_ex =  MAX( at_i(ji,jj) - amax , 0.0 )        
+            DO jl  = 1, jpl
+               zindb   =  MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) 
+               z_da_i = a_i(ji,jj,jl) * z_da_ex / MAX( at_i(ji,jj), epsi06 ) * zindb
+               a_i(ji,jj,jl) = a_i(ji,jj,jl) - z_da_i
+           END DO
+         END DO 
+      END DO 
+      at_i(:,:) = a_i(:,:,1)
+      DO jl = 2, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+
+      ! Final thickness distribution rebinning
+      ! --------------------------------------
+      DO jm = 1, jpm
+         jbnd1 = ice_cat_bounds(jm,1)
+         jbnd2 = ice_cat_bounds(jm,2)
+         IF (ice_ncat_types(jm) .GT. 1 ) CALL lim_itd_th_reb(jbnd1, jbnd2, jm)
+         IF (ice_ncat_types(jm) .EQ. 1 ) THEN
+         ENDIF
+      END DO
+
+      !---------------------
+      ! 2.11) Ice salinity
+      !---------------------
+      !clem@bug: smv_i should be updated too: smv_i(:,:,:) = smv_i(:,:,:) + sm_i(:,:,:) * ( v_i(:,:,:) - zviold(:,:,:) )
+      IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) THEN ! general case
+
+         DO jl = 1, jpl
+            !DO jk = 1, nlay_i
+               DO jj = 1, jpj 
+                  DO ji = 1, jpi
+                     ! salinity stays in bounds
+                     smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)),0.1 * v_i(ji,jj,jl) )
+                     i_ice_switch    =  1.0-MAX(0.0,SIGN(1.0,-v_i(ji,jj,jl) + epsi20))
+                     smv_i(ji,jj,jl)  = i_ice_switch*smv_i(ji,jj,jl) + 0.1*(1.0-i_ice_switch)*v_i(ji,jj,jl)
+                  END DO ! ji
+               END DO ! jj
+            !END DO !jk
+         END DO !jl
+
+      ENDIF
+
+      at_i(:,:) = a_i(:,:,1)
+      DO jl = 2, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+
+
+      !--------------------------------
+      ! Update mass/salt fluxes (clem)
+      !--------------------------------
+      DO jl = 1, jpl
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+               diag_res_pr(ji,jj) = diag_res_pr(ji,jj) + ( v_i(ji,jj,jl) - zviold(ji,jj,jl) ) / rdt_ice 
+               rdmicif(ji,jj) = rdmicif(ji,jj) + ( v_i(ji,jj,jl) - zviold(ji,jj,jl) ) * rhoic 
+               rdmsnif(ji,jj) = rdmsnif(ji,jj) + ( v_s(ji,jj,jl) - zvsold(ji,jj,jl) ) * rhosn 
+               fsalt_res(ji,jj) = fsalt_res(ji,jj) - ( smv_i(ji,jj,jl) - zsmvold(ji,jj,jl) ) * rhoic / rdt_ice 
+            END DO
+         END DO
+      END DO
+  
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_fs  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) ) - zchk_fs_b
+         zchk_fw  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) ) - zchk_fw_b
+ 
+         zchk_v_i = ( glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_v_i_b - ( zchk_fw / rhoic ) ) / rdt_ice
+         zchk_smv = ( glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_smv_b ) / rdt_ice + ( zchk_fs / rhoic )
+
+         IF(lwp) THEN
+            IF (    ABS( zchk_v_i   ) >  1.e-5 ) WRITE(numout,*) 'violation volume [m3/day]     (limupdate1) = ',(zchk_v_i * 86400.)
+            IF (    ABS( zchk_smv   ) >  1.e-4 ) WRITE(numout,*) 'violation saline [psu*m3/day] (limupdate1) = ',(zchk_smv * 86400.)
+            IF ( MINVAL( v_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation v_i<0  [mm]         (limupdate1) = ',(MINVAL(v_i) * 1.e-3)
+            IF ( MAXVAL( SUM(a_i(:,:,:),dim=3) ) >  amax+epsi10 ) WRITE(numout,*) 'violation a_i>amax    (limupdate1) = ',MAXVAL(SUM(a_i,dim=3))
+            IF ( MINVAL( a_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation a_i<0               (limupdate1) = ',MINVAL(a_i)
+         ENDIF
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+
+      IF(ln_ctl) THEN   ! Control print
+         CALL prt_ctl_info(' ')
+         CALL prt_ctl_info(' - Cell values : ')
+         CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
+         CALL prt_ctl(tab2d_1=area       , clinfo1=' lim_update1  : cell area   :')
+         CALL prt_ctl(tab2d_1=at_i       , clinfo1=' lim_update1  : at_i        :')
+         CALL prt_ctl(tab2d_1=vt_i       , clinfo1=' lim_update1  : vt_i        :')
+         CALL prt_ctl(tab2d_1=vt_s       , clinfo1=' lim_update1  : vt_s        :')
+         CALL prt_ctl(tab2d_1=strength   , clinfo1=' lim_update1  : strength    :')
+         CALL prt_ctl(tab2d_1=u_ice      , clinfo1=' lim_update1  : u_ice       :', tab2d_2=v_ice      , clinfo2=' v_ice       :')
+         CALL prt_ctl(tab2d_1=d_u_ice_dyn, clinfo1=' lim_update1  : d_u_ice_dyn :', tab2d_2=d_v_ice_dyn, clinfo2=' d_v_ice_dyn :')
+         CALL prt_ctl(tab2d_1=old_u_ice  , clinfo1=' lim_update1  : old_u_ice   :', tab2d_2=old_v_ice  , clinfo2=' old_v_ice   :')
+
+         DO jl = 1, jpl
+            CALL prt_ctl_info(' ')
+            CALL prt_ctl_info(' - Category : ', ivar1=jl)
+            CALL prt_ctl_info('   ~~~~~~~~~~')
+            CALL prt_ctl(tab2d_1=ht_i       (:,:,jl)        , clinfo1= ' lim_update1  : ht_i        : ')
+            CALL prt_ctl(tab2d_1=ht_s       (:,:,jl)        , clinfo1= ' lim_update1  : ht_s        : ')
+            CALL prt_ctl(tab2d_1=t_su       (:,:,jl)        , clinfo1= ' lim_update1  : t_su        : ')
+            CALL prt_ctl(tab2d_1=t_s        (:,:,1,jl)      , clinfo1= ' lim_update1  : t_snow      : ')
+            CALL prt_ctl(tab2d_1=sm_i       (:,:,jl)        , clinfo1= ' lim_update1  : sm_i        : ')
+            CALL prt_ctl(tab2d_1=o_i        (:,:,jl)        , clinfo1= ' lim_update1  : o_i         : ')
+            CALL prt_ctl(tab2d_1=a_i        (:,:,jl)        , clinfo1= ' lim_update1  : a_i         : ')
+            CALL prt_ctl(tab2d_1=old_a_i    (:,:,jl)        , clinfo1= ' lim_update1  : old_a_i     : ')
+            CALL prt_ctl(tab2d_1=d_a_i_trp  (:,:,jl)        , clinfo1= ' lim_update1  : d_a_i_trp   : ')
+            CALL prt_ctl(tab2d_1=v_i        (:,:,jl)        , clinfo1= ' lim_update1  : v_i         : ')
+            CALL prt_ctl(tab2d_1=old_v_i    (:,:,jl)        , clinfo1= ' lim_update1  : old_v_i     : ')
+            CALL prt_ctl(tab2d_1=d_v_i_trp  (:,:,jl)        , clinfo1= ' lim_update1  : d_v_i_trp   : ')
+            CALL prt_ctl(tab2d_1=v_s        (:,:,jl)        , clinfo1= ' lim_update1  : v_s         : ')
+            CALL prt_ctl(tab2d_1=old_v_s    (:,:,jl)        , clinfo1= ' lim_update1  : old_v_s     : ')
+            CALL prt_ctl(tab2d_1=d_v_s_trp  (:,:,jl)        , clinfo1= ' lim_update1  : d_v_s_trp   : ')
+            CALL prt_ctl(tab2d_1=e_i        (:,:,1,jl)/1.0e9, clinfo1= ' lim_update1  : e_i1        : ')
+            CALL prt_ctl(tab2d_1=old_e_i    (:,:,1,jl)/1.0e9, clinfo1= ' lim_update1  : old_e_i1    : ')
+            CALL prt_ctl(tab2d_1=d_e_i_trp  (:,:,1,jl)/1.0e9, clinfo1= ' lim_update1  : de_i1_trp   : ')
+            CALL prt_ctl(tab2d_1=e_i        (:,:,2,jl)/1.0e9, clinfo1= ' lim_update1  : e_i2        : ')
+            CALL prt_ctl(tab2d_1=old_e_i    (:,:,2,jl)/1.0e9, clinfo1= ' lim_update1  : old_e_i2    : ')
+            CALL prt_ctl(tab2d_1=d_e_i_trp  (:,:,2,jl)/1.0e9, clinfo1= ' lim_update1  : de_i2_trp   : ')
+            CALL prt_ctl(tab2d_1=e_s        (:,:,1,jl)      , clinfo1= ' lim_update1  : e_snow      : ')
+            CALL prt_ctl(tab2d_1=old_e_s    (:,:,1,jl)      , clinfo1= ' lim_update1  : old_e_snow  : ')
+            CALL prt_ctl(tab2d_1=d_e_s_trp  (:,:,1,jl)/1.0e9, clinfo1= ' lim_update1  : d_e_s_trp   : ')
+            CALL prt_ctl(tab2d_1=smv_i      (:,:,jl)        , clinfo1= ' lim_update1  : smv_i       : ')
+            CALL prt_ctl(tab2d_1=old_smv_i  (:,:,jl)        , clinfo1= ' lim_update1  : old_smv_i   : ')
+            CALL prt_ctl(tab2d_1=d_smv_i_trp(:,:,jl)        , clinfo1= ' lim_update1  : d_smv_i_trp : ')
+            CALL prt_ctl(tab2d_1=oa_i       (:,:,jl)        , clinfo1= ' lim_update1  : oa_i        : ')
+            CALL prt_ctl(tab2d_1=old_oa_i   (:,:,jl)        , clinfo1= ' lim_update1  : old_oa_i    : ')
+            CALL prt_ctl(tab2d_1=d_oa_i_trp (:,:,jl)        , clinfo1= ' lim_update1  : d_oa_i_trp  : ')
+            CALL prt_ctl(tab2d_1=REAL(patho_case(:,:,jl))   , clinfo1= ' lim_update1  : Path. case  : ')
+
+            DO jk = 1, nlay_i
+               CALL prt_ctl_info(' - Layer : ', ivar1=jk)
+               CALL prt_ctl(tab2d_1=t_i(:,:,jk,jl) , clinfo1= ' lim_update1  : t_i       : ')
+            END DO
+         END DO
+
+         CALL prt_ctl_info(' ')
+         CALL prt_ctl_info(' - Heat / FW fluxes : ')
+         CALL prt_ctl_info('   ~~~~~~~~~~~~~~~~~~ ')
+         CALL prt_ctl(tab2d_1=fmmec  , clinfo1= ' lim_update1 : fmmec : ', tab2d_2=fhmec     , clinfo2= ' fhmec     : ')
+         CALL prt_ctl(tab2d_1=sst_m  , clinfo1= ' lim_update1 : sst   : ', tab2d_2=sss_m     , clinfo2= ' sss       : ')
+         CALL prt_ctl(tab2d_1=fhbri  , clinfo1= ' lim_update1 : fhbri : ', tab2d_2=fheat_rpo , clinfo2= ' fheat_rpo : ')
+
+         CALL prt_ctl_info(' ')
+         CALL prt_ctl_info(' - Stresses : ')
+         CALL prt_ctl_info('   ~~~~~~~~~~ ')
+         CALL prt_ctl(tab2d_1=utau       , clinfo1= ' lim_update1 : utau      : ', tab2d_2=vtau       , clinfo2= ' vtau      : ')
+         CALL prt_ctl(tab2d_1=utau_ice   , clinfo1= ' lim_update1 : utau_ice  : ', tab2d_2=vtau_ice   , clinfo2= ' vtau_ice  : ')
+         CALL prt_ctl(tab2d_1=u_oce      , clinfo1= ' lim_update1 : u_oce     : ', tab2d_2=v_oce      , clinfo2= ' v_oce     : ')
+      ENDIF
+   
+
+      CALL wrk_dealloc( jkmax, zthick0, zqm0 )
+
+      CALL wrk_dealloc( jpi,jpj,jpl,zviold, zvsold, zsmvold )   ! clem
+
+   END SUBROUTINE lim_update1
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option         Empty Module               No sea-ice model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE lim_update1     ! Empty routine
+   END SUBROUTINE lim_update1
+
+#endif
+
+END MODULE limupdate1
